--------------------------------------------------------------------------------
-- Weapon Medikit Drop
-- Script by DC, August 2009, www.UnrealSoftware.de
-- modified by Kiffer-Opa
--------------------------------------------------------------------------------

-- Setup Tables
if ccm==nil then ccm={} end
ccm.medikitdrop={}
ccm.medikitdrop.plane={}

-- Load & Prepare Ressources
ccm.medikitdrop.gfx_wpn=loadgfx("weapons/rc.bmp")				-- Weapon Image
setmidhandle(ccm.medikitdrop.gfx_wpn)
ccm.medikitdrop.gfx_icon=loadgfx("weapons/medikitdrop.png")			-- Weapon Icon
setmidhandle(ccm.medikitdrop.gfx_icon)
ccm.medikitdrop.gfx_plane=loadgfx("weapons/medikit_airplane.png")		-- Plane icon
setmidhandle(ccm.medikitdrop.gfx_plane)
ccm.medikitdrop.sfx_attack=loadsfx("airstrike.ogg")				-- Attack Sound
ccm.medikitdrop.sfx_incoming=loadsfx("supplyincoming.ogg")


ccm.medikitdrop.id=addweapon("ccm.medikitdrop","Medikit Drop",ccm.medikitdrop.gfx_icon,0,1)

--------------
-- Airplane --
--------------
ccm.medikitdrop.plane.id=addprojectile("ccm.medikitdrop.plane")

function ccm.medikitdrop.plane.draw(id)
	local dir
	-- direction
	if(projectiles[id].sx>0) then
		dir=1
	else
		dir=-1
	end
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(dir,1)
	setrotation(0)
	drawimage(ccm.medikitdrop.gfx_plane,projectiles[id].x,projectiles[id].y)
end

function ccm.medikitdrop.plane.update(id)
	local dir
	if(projectiles[id].sx>0) then
		dir=1
	else
		dir=-1
	end
	-- Particles
	particle(p_smoke, projectiles[id].x-55*dir, projectiles[id].y+11)
	particlespeed(math.random(-2,2)*0.1, math.random(-2,2)*0.1)
	particlefadealpha(0.01)
	
	particle(p_lightpuff,projectiles[id].x-55*dir, projectiles[id].y+11)
	particlefadealpha(0.04)

	-- move
	projectiles[id].x=projectiles[id].x+projectiles[id].sx

	if(dir==1 and projectiles[id].x>=projectiles[id].dropx) or (dir==-1 and projectiles[id].x<=projectiles[id].dropx) then
		if(projectiles[id].medis>=1) then
			playsound(ccm.medikitdrop.sfx_incoming)
			createobject(o_medikit,projectiles[id].dropx,-100)
			projectiles[id].medis=projectiles[id].medis-1
		end
	end
			
	-- remove plane
	if(dir==1 and projectiles[id].x>projectiles[id].dropx+1000 and projectiles[id].x>(getmapwidth()+1000)) or (dir==-1 and projectiles[id].x<projectiles[id].dropx-1000 and projectiles[id].x<-1000) then
		freeprojectile(id)
	end
end

------------------
-- Medikit Drop --
------------------

function ccm.medikitdrop.draw()													-- Draw
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	drawinhand(ccm.medikitdrop.gfx_wpn,7,0)
	-- HUD Positioning
	if weapon_shots==0 then
		hudpositioning(pos_invisible)
	end
end

function ccm.medikitdrop.attack(attack)									-- Attack
	if (weapon_shots<=0) and (weapon_position==1) then
		-- use item and allow to use another one
		useweapon(1)
		playsound(ccm.medikitdrop.sfx_attack)
		weapon_shots=weapon_shots+1
		id=createprojectile(ccm.medikitdrop.plane.id)
		projectiles[id]={}
		if(getplayerdirection(0)==1) then
			projectiles[id].x=math.min(weapon_x-1000, -1000)
			projectiles[id].sx=40
		else
			projectiles[id].x=math.max(weapon_x+1000, getmapwidth()+1000)
			projectiles[id].sx=-40
		end
		projectiles[id].dropx=weapon_x
		projectiles[id].y=-112
		projectiles[id].medis=1
		scroll(weapon_x,0)
	end
end
