--------------------------------------------------------------------------------
-- Weapon No Wind
-- Original Carnage Contest Weapon
-- Script by DC, September 2009, www.UnrealSoftware.de
--------------------------------------------------------------------------------

-- Setup Tables
if ccm==nil then ccm={} end
ccm.nowind={}

-- Load & Prepare Ressources
ccm.nowind.gfx_wpn=loadgfx("weapons/nowind.png")							-- Weapon Image
setmidhandle(ccm.nowind.gfx_wpn)
ccm.nowind.sfx_fadeout=loadsfx("windfadeout.ogg")

--------------------------------------------------------------------------------
-- Weapon: No Wind
--------------------------------------------------------------------------------

ccm.nowind.id=addweapon("ccm.nowind","No Wind",ccm.nowind.gfx_wpn,0)		-- Add Weapon (0 uses)

function ccm.nowind.draw()												-- Draw
	-- icon above head
	if (weapon_shots<=0) then
		setblend(blend_alpha)
		setalpha(1)
		setcolor(255,255,255)
		setscale(0.5+math.abs(math.sin(math.rad(weapon_charge)))*0.5,0.5+math.cos(math.sin(math.rad(weapon_charge)))*0.5)
		drawimage(ccm.nowind.gfx_wpn,getplayerx(0),getplayery(0)-35)
		-- Animation
		weapon_charge=weapon_charge+5
	end
end

function ccm.nowind.attack(attack)										-- Attack
	if (weapon_shots<=0) then
		if (attack==1) then
			-- Use weapon and allow to use another one afterwards (1)
			useweapon(1)
			weapon_shots=weapon_shots+1
			-- No Wind
			playsound(ccm.nowind.sfx_fadeout)
			wind(0.0)
		end
	end
end