--------------------------------------------------------------------------------
-- Weapon Self-Healing
-- Original Carnage Contest Weapon
-- Script by DC, August 2009, www.UnrealSoftware.de
-- modified by Kiffer-Opa
--------------------------------------------------------------------------------

-- Setup Tables
if ccm==nil then ccm={} end
ccm.selfhealing={}

-- Load & Prepare Ressources
ccm.selfhealing.gfx_wpn=loadgfx("weapons/selfhealing.png")						-- Weapon Image
setmidhandle(ccm.selfhealing.gfx_wpn)
ccm.selfhealing.sfx_heal=loadsfx("selfhealing.ogg")

--------------------------------------------------------------------------------
-- Weapon: Self-Healing
--------------------------------------------------------------------------------

ccm.selfhealing.id=addweapon("ccm.selfhealing","Self-Healing",ccm.selfhealing.gfx_wpn,1,2)	-- Add Weapon (1 use, first in round 2)

function ccm.selfhealing.draw()												-- Draw
	-- icon above head
	if (weapon_shots<=0) then
		setblend(blend_alpha)
		setalpha(1)
		setcolor(255,255,255)
		setscale(0.5+math.abs(math.sin(math.rad(weapon_charge)))*0.5,0.5+math.cos(math.sin(math.rad(weapon_charge)))*0.5)
		drawimage(ccm.selfhealing.gfx_wpn,getplayerx(0),getplayery(0)-30)
		-- Animation
		weapon_charge=weapon_charge+5
	end
end

function ccm.selfhealing.attack(attack)										-- Attack
	if (weapon_shots<=0) then
		if (attack==1) then
			-- No more weapon switching!
			useweapon(0)
			weapon_shots=weapon_shots+1
			-- Heal
			playerheal(0,50)
			playerstate(0,state_poisoned,0)
			-- Effect
			playsound(ccm.selfhealing.sfx_heal)
			x=getplayerx(0)
			y=getplayery(0)+3
			particle(p_muzzle,x,y)
			particlesize(1,1)
			particlecolor(255,0,0)
			particlealpha(1.0)
			particlefadealpha(0.01)
			particle(p_muzzle,x,y)
			particlesize(1,2)
			particlecolor(255,0,0)
			particlealpha(1.0)
			particlefadealpha(0.02)
			particlerotation(0)
			for j=1,15,1 do
				particle(p_lightpuff,x-10.0+math.random()*20.0,y+math.random()*10.0)
				particlesize(3.0,3.0)
				particlecolor(255,0,0)
				particlespeed(0,math.random(2,15)*-0.1)
				particlefadealpha(0.01)
			end
			-- End Turn
			endturn()
		end
	end
end