--------------------------------------------------------------------------------
-- Weapon Stealht Ninja
-- Original Carnage Contest Weapon
-- Script by DC, September 2010, www.UnrealSoftware.de
-- modified by Kiffer-Opa
--------------------------------------------------------------------------------

-- Setup Tables
if ccm==nil then ccm={} end
ccm.stealth={}

-- Load & Prepare Ressources
ccm.stealth.gfx_wpn=loadgfx("weapons/stealthninja.png")					-- Weapon Image
setmidhandle(ccm.stealth.gfx_wpn)
ccm.stealth.sfx_heal=loadsfx("stealthninja.ogg")

--------------------------------------------------------------------------------
-- Weapon: Stealth Ninja
--------------------------------------------------------------------------------

ccm.stealth.id=addweapon("ccm.stealth","Stealth Ninja",ccm.stealth.gfx_wpn,0)	-- Add Weapon (0 uses)

function ccm.stealth.draw()												-- Draw
	-- icon above head
	if (weapon_shots<=0) then
		setcolor(255,255,255)
		setblend(blend_alpha)
		setalpha(0.5)
		setscale(0.5+math.abs(math.sin(math.rad(weapon_charge)))*0.5,0.5+math.cos(math.sin(math.rad(weapon_charge)))*0.5)
		drawimage(ccm.stealth.gfx_wpn,getplayerx(0),getplayery(0)-40)
		-- Animation
		weapon_charge=weapon_charge+5
	end
end

function ccm.stealth.attack(attack)										-- Attack
	if (weapon_shots<=0) then
		if (attack==1) then
			-- Use weapon and allow to use another one afterwards (1)
			useweapon(1)
			weapon_shots=weapon_shots+1
			-- Make invisible
			playerstate(0,state_invisible,1)
			-- Effect
			playsound(ccm.stealth.sfx_heal)
			x=getplayerx(0)
			y=getplayery(0)+3
			particle(p_muzzle,x,y)
			particlesize(1,1)
			particlecolor(255,0,150)
			particlealpha(1.0)
			particlefadealpha(0.01)
			particle(p_muzzle,x,y)
			particlesize(1,2)
			particlecolor(255,0,150)
			particlealpha(1.0)
			particlefadealpha(0.02)
			particlerotation(0)
			for j=1,15,1 do
				particle(p_flare,x-10.0+math.random()*20.0,y+math.random()*10.0)
				particlesize(3.0,3.0)
				particlecolor(255,0,150)
				particlespeed(0,math.random(2,15)*-0.1)
				particlefadealpha(0.01)
			end
		end
	end
end