--------------------------------------------------------------------------------
-- Weapon Mine Drop
-- Script by DC, August 2009, www.UnrealSoftware.de
-- modified by Kiffer-Opa
--------------------------------------------------------------------------------

-- Setup Tables
if ccm==nil then ccm={} end
ccm.supplyorder={}
ccm.supplyorder.plane={}

-- Load & Prepare Ressources
ccm.supplyorder.gfx_wpn=loadgfx("weapons/rc.bmp")					-- Weapon Image
setmidhandle(ccm.supplyorder.gfx_wpn)
ccm.supplyorder.gfx_icon=loadgfx("weapons/supplyorder.png")				-- Weapon Icon
setmidhandle(ccm.supplyorder.gfx_icon)
ccm.supplyorder.gfx_plane=loadgfx("weapons/supply_airplane.png")		-- Plane icon
setmidhandle(ccm.supplyorder.gfx_plane)
ccm.supplyorder.sfx_attack=loadsfx("airstrike.ogg")				-- Attack Sound
ccm.supplyorder.sfx_incoming=loadsfx("supplyincoming.ogg")

--------------------------------------------------------------------------------
-- Weapon: Mine Drop 
--------------------------------------------------------------------------------
ccm.supplyorder.id=addweapon("ccm.supplyorder","Supply Order",ccm.supplyorder.gfx_icon,0,1)

--------------
-- Airplane --
--------------
ccm.supplyorder.plane.id=addprojectile("ccm.supplyorder.plane")

function ccm.supplyorder.plane.draw(id)
	local dir
	-- direction
	if(projectiles[id].sx>0) then
		dir=1
	else
		dir=-1
	end
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(dir,1)
	setrotation(0)
	drawimage(ccm.supplyorder.gfx_plane,projectiles[id].x,projectiles[id].y)
end

function ccm.supplyorder.plane.update(id)
	local dir
	if(projectiles[id].sx>0) then
		dir=1
	else
		dir=-1
	end
	-- Particles
	particle(p_smoke, projectiles[id].x-55*dir, projectiles[id].y+11)
	particlespeed(math.random(-2,2)*0.1, math.random(-2,2)*0.1)
	particlefadealpha(0.01)
	
	particle(p_lightpuff,projectiles[id].x-55*dir, projectiles[id].y+11)
	particlefadealpha(0.04)

	-- move
	projectiles[id].x=projectiles[id].x+projectiles[id].sx

	local dropx = projectiles[id].throwindex*50*dir
	if(dir==1 and projectiles[id].x>=projectiles[id].dropx+dropx) or (dir==-1 and projectiles[id].x<=projectiles[id].dropx+dropx) then
		if(projectiles[id].throwindex<=2) then
			if(projectiles[id].throwindex==-2) then
				playsound(ccm.supplyorder.sfx_incoming)
			end
			-- Throw supply
			createobject(o_supply,projectiles[id].dropx+dropx,-100)
			projectiles[id].throwindex=projectiles[id].throwindex+1
		end
	end

		
	-- remove plane
	if(dir==1 and projectiles[id].x>projectiles[id].dropx+1000 and projectiles[id].x>(getmapwidth()+1000)) or (dir==-1 and projectiles[id].x<projectiles[id].dropx-1000 and projectiles[id].x<-1000) then
		freeprojectile(id)
	end
end

------------------
-- Supply Order --
------------------

function ccm.supplyorder.draw()													-- Draw
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	drawinhand(ccm.supplyorder.gfx_wpn,7,0)
	-- HUD Positioning
	if weapon_shots==0 then
		hudpositioning(pos_invisible)
	end
end

function ccm.supplyorder.attack(attack)									-- Attack
	if (weapon_shots<=0) and (weapon_position==1) then
		-- use item and allow to use another one
		useweapon(1)
		playsound(ccm.supplyorder.sfx_attack)
		weapon_shots=weapon_shots+1
		id=createprojectile(ccm.supplyorder.plane.id)
		projectiles[id]={}
		if(getplayerdirection(0)==1) then
			projectiles[id].x=math.min(weapon_x-1000, -1000)
			projectiles[id].sx=40
		else
			projectiles[id].x=math.max(weapon_x+1000, getmapwidth()+1000)
			projectiles[id].sx=-40
		end
		projectiles[id].dropx=weapon_x
		projectiles[id].y=-112
		projectiles[id].throwindex=-2
		scroll(weapon_x,0)
	end
end
