--------------------------------------------------------------------------------
-- Weapon Flood
-- Original Carnage Contest Weapon
-- Script by DC, September 2009, www.UnrealSoftware.de
-- modded by Kiffer-Opa
--------------------------------------------------------------------------------

-- Setup Tables
if ccm==nil then ccm={} end
ccm.flood={}

-- Load & Prepare Ressources
ccm.flood.gfx_wpn=loadgfx("weapons/flood.bmp")							-- Weapon Image
setmidhandle(ccm.flood.gfx_wpn)
ccm.flood.gfx_marker=loadgfx("weapons/waterstream.png")
ccm.flood.gfx_pixel=loadgfx("weapons/pixel.bmp")
ccm.flood.sfx_attack=loadsfx("flood.ogg")								-- flood Sound
ccm.flood.helpmarker = true										-- show a line which shows where the water will stop (true) or not (false)

--------------------------------------------------------------------------------
-- Weapon: Flood
--------------------------------------------------------------------------------

ccm.flood.id=addweapon("ccm.flood","Flood",ccm.flood.gfx_wpn,0,2)			-- Add Weapon (0 uses, first in round 2)
ccm.flood.markery = getwatery()-138

function ccm.flood.draw()												-- Draw
	if(ccm.flood.helpmarker==true) then
		-- flood marker
		
		setblend(blend_alpha)
		setalpha(0.3)
		setcolor(100,100,255)
		setscale(getmapwidth()*3, 1)
		drawimage(ccm.flood.gfx_marker, -getmapwidth(), ccm.flood.markery-24)

		setscale(getmapwidth()*3, 138)
		drawimage(ccm.flood.gfx_pixel, -getmapwidth(), ccm.flood.markery+1)
		
		setalpha(0.3)
		setcolor(0,0,255)
		setscale(getmapwidth()*3, 1)
		drawimage(ccm.flood.gfx_pixel, -getmapwidth(), ccm.flood.markery)
	end
	
	-- icon above head
	if (weapon_shots<=0) then
		setblend(blend_alpha)
		setalpha(1)
		setcolor(255,255,255)
		setscale(0.5+math.abs(math.sin(math.rad(weapon_charge)))*0.5,0.5+math.cos(math.sin(math.rad(weapon_charge)))*0.5)
		drawimage(ccm.flood.gfx_wpn,getplayerx(0),getplayery(0)-30)
		-- Animation
		weapon_charge=weapon_charge+5	
		
		ccm.flood.markery = getwatery()-138
	end	
end

function ccm.flood.attack(attack)										-- Attack
	if (weapon_shots<=0) then
		if (attack==1) then
			-- No more weapon switching!
			useweapon(0)
			weapon_shots=weapon_shots+1
			-- Effect
			playsound(ccm.flood.sfx_attack)
			-- Raise Water
			watery(getwatery()-150)
			
			-- End Turn
			endturn()
		end
	end
end