--------------------------------------------------------------------------------
-- Weapon For Allah
-- Original Carnage Contest Weapon
-- Script by DC, September 2009, www.UnrealSoftware.de
-- slightly modded by Kiffer-Opa
--------------------------------------------------------------------------------

-- Setup Tables
if ccm==nil then ccm={} end
ccm.allah={}

-- Load & Prepare Ressources
ccm.allah.gfx_icon=loadgfx("weapons/allah.png")							-- Weapon Icon
setmidhandle(ccm.allah.gfx_icon)
ccm.allah.gfx_wpn=loadgfx("weapons/belt.bmp")							-- Weapon Image
setmidhandle(ccm.allah.gfx_wpn)

--------------------------------------------------------------------------------
-- Weapon: For Allah
--------------------------------------------------------------------------------

ccm.allah.id=addweapon("ccm.allah","For Allah!",ccm.allah.gfx_icon,100,1)

function ccm.allah.draw()												-- Draw
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setrotation(0)
	hudinfo("Attention: Hitting [Space] with this weapon will kill your whole team!")
	-- Draw at each player of team
	players=playertable()
	for i=1,#players,1 do
		if getplayerhealth(players[i])>0 and getplayerteam(players[i])==getplayerteam(0) then
			setscale(getplayerdirection(players[i]),1)
			drawimage(ccm.allah.gfx_wpn,getplayerx(players[i]),getplayery(players[i])+7)
		end
	end
end

function ccm.allah.attack(attack)										-- Attack
	if (weapon_shots<=0) then
		if (attack==1) then
			-- No more weapon switching!
			useweapon(0)
			weapon_shots=weapon_shots+1
			-- Suicide for each player of team
			players=playertable()
			for i=1,#players,1 do
				if getplayerhealth(players[i])>0 and getplayerteam(players[i])==getplayerteam(0) then
					-- Suicide
					playerdamage(players[i],getplayerhealth(players[i]))
					-- Cause damage
					arealdamage(getplayerx(players[i]),getplayery(players[i]),120,90)
					-- Destroy terrain
					terrainexplosion(getplayerx(players[i]),getplayery(players[i]),50,1)
					-- Crater
					grey=math.random(0,40)
					if math.random(0,1)==1 then
						terrainalphaimage(gfx_crater150,getplayerx(players[i]),getplayery(players[i]),math.random(6,9)*0.1,grey,grey,grey)
					else
						terrainalphaimage(gfx_crater175,getplayerx(players[i]),getplayery(players[i]),math.random(6,9)*0.1,grey,grey,grey)
					end
				end
			end
			-- End Turn
			endturn()
		end
	end
end