--------------------------------------------------------------------------------
-- Weapon Heavy Airstrike + Projectile Cluster
-- Original Carnage Contest Weapon
-- Script by DC, September 2009, www.UnrealSoftware.de
-- modified by Kiffer-Opa on June 2011
--------------------------------------------------------------------------------

-- Setup Tables
if ccm==nil then ccm={} end
ccm.heavyairstrike={}
ccm.heavyairstrike.cluster={}
ccm.heavyairstrike.plane={}

-- Load & prepare resources
ccm.heavyairstrike.gfx_wpn=loadgfx("weapons/rc.bmp")				-- Weapon image
setmidhandle(ccm.heavyairstrike.gfx_wpn)
ccm.heavyairstrike.gfx_icon=loadgfx("weapons/heavyairstrikeicon.png")		-- Weapon icon
setmidhandle(ccm.heavyairstrike.gfx_icon)
ccm.heavyairstrike.gfx_pro=loadgfx("weapons/cluster.bmp")			-- Projectile image
setmidhandle(ccm.heavyairstrike.gfx_pro)
ccm.heavyairstrike.gfx_plane=loadgfx("weapons/airstrike_airplane.png")	-- Airplane image
setmidhandle(ccm.heavyairstrike.gfx_plane)
ccm.heavyairstrike.sfx_attack=loadsfx("airstrike.ogg")				-- Attack sound

--------------------------------------------------------------------------------
-- Weapon: Heavy Airstrike
--------------------------------------------------------------------------------

ccm.heavyairstrike.id=addweapon("ccm.heavyairstrike","Heavy Air Strike",ccm.heavyairstrike.gfx_icon,0,3)	-- Add weapon (0 uses, first in round 3)

function ccm.heavyairstrike.draw()						-- Draw
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	drawinhand(ccm.heavyairstrike.gfx_wpn,7,0)
	-- HUD Positioning
	if weapon_shots==0 then
		hudpositioning(pos_invisible)
	end
end

function ccm.heavyairstrike.attack(attack)					-- Attack
	if (weapon_shots<=0) and (weapon_position==1) then
		-- No more weapon switching!
		useweapon(0)
		playsound(ccm.heavyairstrike.sfx_attack)
		weapon_shots=weapon_shots+1
		-- Attack
--[[		for i=0,2,1 do
			for j=-2,2,1 do
				pid=createprojectile(ccm.heavyairstrike.cluster.id)
				projectiles[pid]={}
				projectiles[pid].x=weapon_x+(j*15)
				projectiles[pid].y=-500-(i*500)
				projectiles[pid].sx=0
				projectiles[pid].sy=5.0
				if i==0 and j==0 then projectiles[pid].follow=1 end
			end
		end]]
		local id
		
		-- create airplanes
		for i=0,2 do
			id=createprojectile(ccm.heavyairstrike.plane.id)
			projectiles[id]={}
			if(getplayerdirection(0)==1) then
				projectiles[id].x=math.min(weapon_x-1000-1500*i, -1000-1500*i)
				projectiles[id].sx=40
			else
				projectiles[id].x=math.min(weapon_x+1000+1500*i, getmapwidth()+1000+1500*i)
				projectiles[id].sx=-40
			end
			projectiles[id].y=-512
			projectiles[id].throwindex=-2
			projectiles[id].dropx=weapon_x
			projectiles[id].id=i
		end
		scroll(weapon_x,-512)
		-- End Turn
		endturn()
	end
end

--------------------------------------------------------------------------------
-- Projectile: Airplane
--------------------------------------------------------------------------------
ccm.heavyairstrike.plane.id=addprojectile("ccm.heavyairstrike.plane")

function ccm.heavyairstrike.plane.draw(id)
	local dir
	-- direction
	if(projectiles[id].sx>0) then
		dir=1
	else
		dir=-1
	end
	setblend(blend_alpha)
	setalpha(1)
	setcolor(127,127,127)
	setscale(dir,1)
	setrotation(0)
	drawimage(ccm.heavyairstrike.gfx_plane,projectiles[id].x,projectiles[id].y)
end

function ccm.heavyairstrike.plane.update(id)
	local dir
	if(projectiles[id].sx>0) then
		dir=1
	else
		dir=-1
	end
	-- Particles
	particle(p_smoke, projectiles[id].x-55*dir, projectiles[id].y+11)
	particlespeed(math.random(-2,2)*0.1, math.random(-2,2)*0.1)
	particlefadealpha(0.01)
	
	particle(p_lightpuff,projectiles[id].x-55*dir, projectiles[id].y+11)
	particlefadealpha(0.04)

	-- move
	projectiles[id].x=projectiles[id].x+projectiles[id].sx
	if(projectiles[id].throwindex<=2) then
		local dropx=projectiles[id].throwindex*15*dir
		if(dir==1 and projectiles[id].x>=projectiles[id].dropx+dropx) or (dir==-1 and projectiles[id].x<=projectiles[id].dropx+dropx) then
			-- Attack
			projectiles[id].throwindex=projectiles[id].throwindex+1
			pid=createprojectile(ccm.heavyairstrike.cluster.id)
			projectiles[pid]={}
			projectiles[pid].x=projectiles[id].dropx+dropx
			projectiles[pid].y=-500
			projectiles[pid].sx=dir*0.2
			projectiles[pid].sy=3.0 
			if projectiles[id].id==0 and projectiles[id].throwindex==0 then
				projectiles[pid].follow=true
			else
				projectiles[pid].follow=false
			end
		end
	end
		
	-- remove plane
	if(dir==1 and projectiles[id].x>projectiles[id].dropx+1000 and projectiles[id].x>(getmapwidth()+1000)) or (dir==-1 and projectiles[id].x<projectiles[id].dropx-1000 and projectiles[id].x<-1000) then
		freeprojectile(id)
	end
end

--------------------------------------------------------------------------------
-- Projectile: Cluster
--------------------------------------------------------------------------------

ccm.heavyairstrike.cluster.id=addprojectile("ccm.heavyairstrike.cluster")	-- Add Projectile

function ccm.heavyairstrike.cluster.draw(id)								-- Draw
	-- Setup draw mode
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(1,1)
	-- Calculate projectile rotation
	setrotation(math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy)))
	-- Draw projectile
	drawimage(ccm.heavyairstrike.gfx_pro,projectiles[id].x,projectiles[id].y)
end

function ccm.heavyairstrike.cluster.update(id)							-- Update
	rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
	-- Particle Tail
	particle(p_smoke,projectiles[id].x-math.sin(math.rad(rot))*7,projectiles[id].y+math.cos(math.rad(rot))*7)
	particlespeed(math.random(-2,2)*0.1,math.random(-2,2)*0.1)
	particlefadealpha(0.05)
	-- Gravity influence on speed
	projectiles[id].sy=projectiles[id].sy+getgravity()
	-- Move (in substep loop for optimal collision precision)
	msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
	msubx=projectiles[id].sx/msubt
	msuby=projectiles[id].sy/msubt
	for i=1,msubt,1 do
		projectiles[id].x=projectiles[id].x+msubx
		projectiles[id].y=projectiles[id].y+msuby
		-- Collision
		if collision(col3x3,projectiles[id].x,projectiles[id].y)==1 then
			-- Cause damage
			arealdamage(projectiles[id].x,projectiles[id].y,70,30)
			-- Destroy terrain
			terrainexplosion(projectiles[id].x,projectiles[id].y,30,1)
			-- Crater
			grey=math.random(0,40)
			if math.random(0,1)==1 then
				terrainalphaimage(gfx_crater100,projectiles[id].x,projectiles[id].y,math.random(5,7)*0.1,grey,grey,grey)
			else
				terrainalphaimage(gfx_crater125,projectiles[id].x,projectiles[id].y,math.random(5,7)*0.1,grey,grey,grey)
			end
			-- Free projectile
			freeprojectile(id)
			break
		end
		-- Water
		if (projectiles[id].y)>getwatery()+5 then
			-- Effects
			particle(p_waterhit,projectiles[id].x,projectiles[id].y)
			playsound(sfx_hitwater1)
			-- Free projectile
			freeprojectile(id)
			break
		end
	end
	-- Scroll to projectile
	if projectiles[id].follow==true then
		scroll(projectiles[id].x,projectiles[id].y)
	end
end