--------------------------------------------------------------------------------
-- Weapon Hellfire
-- Original Carnage Contest Weapon
-- Script by DC, September 2009, www.UnrealSoftware.de
-- modded by Kiffer-Opa
--------------------------------------------------------------------------------

-- Setup Tables
if ccm==nil then ccm={} end
ccm.hellfire={}

-- Load & Prepare Ressources
ccm.hellfire.gfx_wpn=loadgfx("weapons/hellfire.png")							-- Weapon Image
setmidhandle(ccm.hellfire.gfx_wpn)
ccm.hellfire.sfx_attack=loadsfx("hellfire.ogg")								-- Hellfire Sound

--------------------------------------------------------------------------------
-- Weapon: Hellfire
--------------------------------------------------------------------------------

ccm.hellfire.id=addweapon("ccm.hellfire","Hellfire",ccm.hellfire.gfx_wpn,0,2)	-- Add Weapon (0 uses, first in round 2)

function ccm.hellfire.draw()													-- Draw
	-- icon above head
	if (weapon_shots<=0) then
		setblend(blend_alpha)
		setalpha(1)
		setcolor(255,255,255)
		setscale(0.5+math.abs(math.sin(math.rad(weapon_charge)))*0.5,0.5+math.cos(math.sin(math.rad(weapon_charge)))*0.5)
		drawimage(ccm.hellfire.gfx_wpn,getplayerx(0),getplayery(0)-30)
		-- Animation
		weapon_charge=weapon_charge+5
	end
end

function ccm.hellfire.attack(attack)											-- Attack
	if (weapon_shots<=0) then
		if (attack==1) then
			-- No more weapon switching!
			useweapon(0)
			weapon_shots=weapon_shots+1
			-- Effects
			playsound(ccm.hellfire.sfx_attack)
			setbgcolor(255,0,0,1.0,0.005)
			-- Fire
			for x=-15*50,getmapwidth()+15*50,50 do
				createobject(o_fire,x,-100)
			end
			-- End Turn
			endturn()
		end
	end
end