--------------------------------------------------------------------------------
-- Weapon Mine Drop
-- Script by DC, August 2009, www.UnrealSoftware.de
-- modified by Kiffer-Opa
--------------------------------------------------------------------------------

-- Setup Tables
if ccm==nil then ccm={} end
ccm.minedrop={}
ccm.minedrop.plane={}

-- Load & Prepare Ressources
ccm.minedrop.gfx_wpn=loadgfx("weapons/rc.bmp")					-- Weapon Image
setmidhandle(ccm.minedrop.gfx_wpn)
ccm.minedrop.gfx_icon=loadgfx("weapons/minedrop.png")				-- Weapon Icon
setmidhandle(ccm.minedrop.gfx_icon)
ccm.minedrop.gfx_plane=loadgfx("weapons/airstrike_airplane.png")		-- Plane icon
setmidhandle(ccm.minedrop.gfx_plane)
ccm.minedrop.sfx_attack=loadsfx("airstrike.ogg")				-- Attack Sound

--------------------------------------------------------------------------------
-- Weapon: Mine Drop 
--------------------------------------------------------------------------------
ccm.minedrop.id=addweapon("ccm.minedrop","Napalm",ccm.minedrop.gfx_icon,0,2)	-- Add Weapon (0 uses, first in round 2)

--------------
-- Airplane --
--------------
ccm.minedrop.plane.id=addprojectile("ccm.minedrop.plane")

function ccm.minedrop.plane.draw(id)
	local dir
	-- direction
	if(projectiles[id].sx>0) then
		dir=1
	else
		dir=-1
	end
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(dir,1)
	setrotation(0)
	drawimage(ccm.minedrop.gfx_plane,projectiles[id].x,projectiles[id].y)
	if(weapon_mode==0) then
		scroll(projectiles[id].x,projectiles[id].y)
	end
end

function ccm.minedrop.plane.update(id)
	local dir
	if(projectiles[id].sx>0) then
		dir=1
	else
		dir=-1
	end
	-- Particles
	particle(p_smoke, projectiles[id].x-55*dir, projectiles[id].y+11)
	particlespeed(math.random(-2,2)*0.1, math.random(-2,2)*0.1)
	particlefadealpha(0.01)
	
	particle(p_lightpuff,projectiles[id].x-55*dir, projectiles[id].y+11)
	particlefadealpha(0.04)

	-- move
	projectiles[id].x=projectiles[id].x+projectiles[id].sx

	if weapon_mode==0 then
		local dropx = projectiles[id].throwindex*40*dir
		if(dir==1 and projectiles[id].x>=projectiles[id].dropx+dropx) or (dir==-1 and projectiles[id].x<=projectiles[id].dropx+dropx) then
			-- Attack
			projectiles[id].throwindex=projectiles[id].throwindex+1
			createobject(o_mine,projectiles[id].dropx+dropx,-163)
			if(projectiles[id].throwindex>2) then
				weapon_mode=1
			end
		end
	end
		
	-- remove plane
	if(dir==1 and projectiles[id].x>projectiles[id].dropx+1000 and projectiles[id].x>(getmapwidth()+1000)) or (dir==-1 and projectiles[id].x<projectiles[id].dropx-1000 and projectiles[id].x<-1000) then
		freeprojectile(id)
	end
end

---------------
-- Mine Drop --
---------------

function ccm.minedrop.draw()													-- Draw
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	drawinhand(ccm.minedrop.gfx_wpn,7,0)
	-- HUD Positioning
	if weapon_shots==0 then
		hudpositioning(pos_invisible)
	end
end

function ccm.minedrop.attack(attack)									-- Attack
	if (weapon_shots<=0) and (weapon_position==1) then
		-- No more weapon switching!
		useweapon(0)
		playsound(ccm.minedrop.sfx_attack)
		weapon_shots=weapon_shots+1
		id=createprojectile(ccm.minedrop.plane.id)
		projectiles[id]={}
		if(getplayerdirection(0)==1) then
			projectiles[id].x=math.min(weapon_x-1000, -1000)
			projectiles[id].sx=40
		else
			projectiles[id].x=math.max(weapon_x+1000, getmapwidth()+1000)
			projectiles[id].sx=-40
		end
		projectiles[id].y=-175
		projectiles[id].throwindex=-2
		projectiles[id].dropx=weapon_x
		weapon_mode=0
		-- End Turn
		endturn()
	end
end
