--------------------------------------------------------------------------------
-- Weapon Napalm
-- Script by DC, August 2009, www.UnrealSoftware.de
-- modified by Kiffer-Opa
--------------------------------------------------------------------------------

-- Setup Tables
if ccm==nil then ccm={} end
ccm.napalm={}
ccm.napalm.plane={}

-- Load & Prepare Ressources
ccm.napalm.gfx_wpn=loadgfx("weapons/rc.bmp")					-- Weapon Image
setmidhandle(ccm.napalm.gfx_wpn)
ccm.napalm.gfx_icon=loadgfx("weapons/napalm.png")				-- Weapon Icon
setmidhandle(ccm.napalm.gfx_icon)
ccm.napalm.gfx_plane=loadgfx("weapons/airstrike_airplane.png")		-- Plane icon
setmidhandle(ccm.napalm.gfx_plane)
ccm.napalm.sfx_attack=loadsfx("airstrike.ogg")				-- Attack Sound

--------------------------------------------------------------------------------
-- Weapon: Napalm 
--------------------------------------------------------------------------------
ccm.napalm.id=addweapon("ccm.napalm","Napalm",ccm.napalm.gfx_icon,1,2)	-- Add Weapon (1 use, first in round 2)

--------------
-- Airplane --
--------------
ccm.napalm.plane.id=addprojectile("ccm.napalm.plane")

function ccm.napalm.plane.draw(id)
	local dir
	-- direction
	if(projectiles[id].sx>0) then
		dir=1
	else
		dir=-1
	end
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(dir,1)
	setrotation(0)
	drawimage(ccm.napalm.gfx_plane,projectiles[id].x,projectiles[id].y)
	if(weapon_mode==0) then
		scroll(projectiles[id].x,projectiles[id].y)
	end
end

function ccm.napalm.plane.update(id)
	local dir
	if(projectiles[id].sx>0) then
		dir=1
	else
		dir=-1
	end
	-- Particles
	particle(p_smoke, projectiles[id].x-55*dir, projectiles[id].y+11)
	particlespeed(math.random(-2,2)*0.1, math.random(-2,2)*0.1)
	particlefadealpha(0.01)
	
	particle(p_lightpuff,projectiles[id].x-55*dir, projectiles[id].y+11)
	particlefadealpha(0.04)

	-- move
	projectiles[id].x=projectiles[id].x+projectiles[id].sx

	if weapon_mode==0 then
		local dropx=projectiles[id].throwindex*17*dir
		if(dir==1 and projectiles[id].x>=weapon_x+dropx) or (dir==-1 and projectiles[id].x<=weapon_x+dropx) then
			-- Attack
			projectiles[id].throwindex=projectiles[id].throwindex+1
			createobject(o_fire,weapon_x+dropx,-100)
			if(projectiles[id].throwindex>2) then
				weapon_mode=1
			end
		end
	end
		
	-- remove plane
	if(dir==1 and projectiles[id].x>weapon_x+1000 and projectiles[id].x>(getmapwidth()+1000)) or (dir==-1 and projectiles[id].x<weapon_x-1000 and projectiles[id].x<-1000) then
		freeprojectile(id)
	end
end

------------
-- Napalm --
------------

function ccm.napalm.draw()													-- Draw
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	drawinhand(ccm.napalm.gfx_wpn,7,0)
	-- HUD Positioning
	if weapon_shots==0 then
		hudpositioning(pos_invisible)
	end
end

function ccm.napalm.attack(attack)									-- Attack
	if (weapon_shots<=0) and (weapon_position==1) then
		-- No more weapon switching!
		useweapon(0)
		playsound(ccm.napalm.sfx_attack)
		weapon_shots=weapon_shots+1
		id=createprojectile(ccm.napalm.plane.id)
		projectiles[id]={}
		if(getplayerdirection(0)==1) then
			projectiles[id].x=math.min(weapon_x-1000, -1000)
			projectiles[id].sx=40
		else
			projectiles[id].x=math.max(weapon_x+1000, getmapwidth()+1000)
			projectiles[id].sx=-40
		end
		projectiles[id].y=-105
		projectiles[id].throwindex=-2
		weapon_mode=0
		-- End Turn
		endturn()
	end
end
