--------------------------------------------------------------------------------
-- Weapon Pandemic
-- modified Carnage Contest Weapon
-- Script by DC, September 2009, www.UnrealSoftware.de
-- modified by Kiffer-Opa
--------------------------------------------------------------------------------

-- Setup Tables
if ccm==nil then ccm={} end
ccm.pandemic={}

-- Load & Prepare Ressources
ccm.pandemic.gfx_wpn=loadgfx("weapons/pandemic.png")							-- Weapon Image
setmidhandle(ccm.pandemic.gfx_wpn)
ccm.pandemic.sfx_attack=loadsfx("pandemic.ogg")								-- pandemic Sound

--------------------------------------------------------------------------------
-- Weapon: Pandemic
--------------------------------------------------------------------------------

ccm.pandemic.id=addweapon("ccm.pandemic","Pandemic",ccm.pandemic.gfx_wpn,0,2)	-- Add Weapon (0 uses, first in round 2)

function ccm.pandemic.draw()													-- Draw
	-- icon above head
	if (weapon_shots<=0) then
		setblend(blend_alpha)
		setalpha(1)
		setcolor(255,255,255)
		setscale(0.5+math.abs(math.sin(math.rad(weapon_charge)))*0.5,0.5+math.cos(math.sin(math.rad(weapon_charge)))*0.5)
		drawimage(ccm.pandemic.gfx_wpn,getplayerx(0),getplayery(0)-30)
		-- Animation
		weapon_charge=weapon_charge+5
	end
end

function ccm.pandemic.attack(attack)											-- Attack
	if (weapon_shots<=0) then
		if (attack==1) then
			-- No more weapon switching!
			useweapon(0)
			weapon_shots=weapon_shots+1
			-- Effect
			playsound(ccm.pandemic.sfx_attack)
			setbgcolor(0,255,0,1.0,0.005)
			-- Poison all Players
			players=playertable()
			for i=1,#players,1 do
				if getplayerhealth(players[i])>0 and players[i]~=playercurrent() then
					playerstate(players[i],state_poisoned,1)
					particle(p_ring,getplayerx(players[i]),getplayery(players[i]))
					particlecolor(0,255,0)
				end
			end
			-- End Turn
			endturn()
		end
	end
end