--------------------------------------------------------------------------------
-- Weapon Quake + Projectile Quake
-- Original Carnage Contest Weapon
-- Script by DC, September 2009, www.UnrealSoftware.de
-- modified by Kiffer-Opa
--------------------------------------------------------------------------------

-- Setup Tables
if ccm==nil then ccm={} end
ccm.quake={}
ccm.quake.quake={}

-- Load & Prepare Ressources
ccm.quake.gfx_wpn=loadgfx("weapons/quake.png")							-- Weapon Image
setmidhandle(ccm.quake.gfx_wpn)
ccm.quake.sfx_attack=loadsfx("quake.ogg")								-- quake Sound

--------------------------------------------------------------------------------
-- Weapon: Quake
--------------------------------------------------------------------------------

ccm.quake.id=addweapon("ccm.quake","Quake",ccm.quake.gfx_wpn,0,2)			-- Add Weapon (0 uses, first in round 2)

function ccm.quake.draw()												-- Draw
	-- icon above head
	if (weapon_shots<=0) then
		setblend(blend_alpha)
		setalpha(1)
		setcolor(255,255,255)
		setscale(1+math.sin(math.rad(weapon_charge))*0.25,1+math.sin(math.rad(weapon_charge))*0.25)
		drawimage(ccm.quake.gfx_wpn,getplayerx(0),getplayery(0)-33)
		-- Animation
		weapon_charge=weapon_charge+5
	end
end

function ccm.quake.attack(attack)										-- Attack
	if (weapon_shots<=0) then
		if (attack==1) then
			-- No more weapon switching!
			useweapon(0)
			weapon_shots=weapon_shots+1
			-- Effect
			playsound(ccm.quake.sfx_attack)
			id=createprojectile(ccm.quake.quake.id)
			projectiles[id]={}
			projectiles[id].timer=50*5
			-- End Turn
			endturn()
		end
	end
end

--------------------------------------------------------------------------------
-- Projectile: Quake
--------------------------------------------------------------------------------

ccm.quake.quake.id=addprojectile("ccm.quake.quake")						-- Add Projectile

function ccm.quake.quake.draw()											-- Draw
	-- Do nothing
end

function ccm.quake.quake.update()										-- Update
	id=projectileid()
	-- Quake effect
	quake(10)
	-- Timer
	projectiles[id].timer=projectiles[id].timer-1
	-- Shake players
	if (projectiles[id].timer%25)==0 then
		players=playertable()
		for i=1,#players,1 do
			p=players[i]
			if getplayerhealth(p)>0 and getplayeraction(p)==0 then
				math.randomseed(p*512+getframe()*14189)
				playerpush(p,math.random(-7,7),math.random(-7,-3))
			end
		end
		
		-- shake all objects but fire
		myobjects=objecttable()
		for i=1,#myobjects,1 do
			local o=myobjects[i]
			if getobjecttype(o)~=o_fire and math.abs(getobjectyspeed(o))<0.05 and math.abs(getobjectxspeed(o))<0.05 then
				math.randomseed(o*512+getframe()*14189)
				objectpush(o,math.random(-7,7),math.random(-7,-3))
			end
		end
		
		
	end
	-- End quake (free projectile)
	if projectiles[id].timer<=0 then
		freeprojectile(id)
	end
end