--------------------------------------------------------------------------------
-- Weapon Winter
-- Original Carnage Contest Weapon
-- Script by DC, September 2009, www.UnrealSoftware.de
--------------------------------------------------------------------------------
-- MODIFICAION BY Kiffer-Opa:
-- There appears the weapon icon about the player if this
-- weapon is selected.
-- The modificated Winter has a new side effect: Besides freezing all
-- players, this weapon also removes all fire on the map.

-- Setup Tables
if ccm==nil then ccm={} end
ccm.winter={}

-- Load & Prepare Ressources
ccm.winter.gfx_wpn=loadgfx("weapons/winter.png")							-- Weapon Image
setmidhandle(ccm.winter.gfx_wpn)
ccm.winter.sfx_attack=loadsfx("winter.ogg")								-- Winter Sound

--------------------------------------------------------------------------------
-- Weapon: Winter
--------------------------------------------------------------------------------

ccm.winter.id=addweapon("ccm.winter","Winter",ccm.winter.gfx_wpn,0,2)		-- Add Weapon (0 uses, first in round 2)

function ccm.winter.draw()												-- Draw
	-- icon above head
	if (weapon_shots<=0) then
		setblend(blend_alpha)
		setalpha(1)
		setcolor(255,255,255)
		setscale(0.5+math.abs(math.sin(math.rad(weapon_charge)))*0.5,0.5+math.cos(math.sin(math.rad(weapon_charge)))*0.5)
		drawimage(ccm.winter.gfx_wpn,getplayerx(0),getplayery(0)-30)
		-- Animation
		weapon_charge=weapon_charge+5
	end
end

function ccm.winter.attack(attack)										-- Attack
	if (weapon_shots<=0) then
		if (attack==1) then
			-- No more weapon switching!
			useweapon(0)
			weapon_shots=weapon_shots+1
			-- Effects
			playsound(ccm.winter.sfx_attack)
			setbgcolor(255,255,255,1.0,0.005)
			-- Freeze Players
			local players=playertable()
			for i=1,#players,1 do
				if getplayerhealth(players[i])>0 and players[i]~=playercurrent() then
					playerstate(players[i],state_frozen,1)
					particle(p_ring,getplayerx(players[i]),getplayery(players[i]))
					particlecolor(255,255,255)
				end
			end
		
			-- Remove all fire
			local fires=objecttable(o_fire)
			for i=1,#fires do
				removeobject(fires[i])
			end
			-- End Turn
			endturn()
		end
	end
end
